<!DOCTYPE html>
<html lang="es">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
  <meta name="Author" content="Brais Arias Rio">

  <title>Introducción a Docker - Despliegue de aplicaciones Symfony con Docker</title>

  <link rel="stylesheet" href="reveal.js/dist/reset.css">
  <link rel="stylesheet" href="reveal.js/dist/reveal.css">
  <link rel="stylesheet" href="reveal.js/dist/theme/black.css" id="theme">


  <!-- Theme used for syntax highlighted code -->
  <link rel="stylesheet" href="reveal.js/plugin/highlight/monokai.css" id="highlight-theme">

  <link rel="stylesheet" href="css/custom.css">
</head>

<body>
  <div class="reveal">
    <div class="slides">

      <section id="portada">
        <h2>Introducción a <em>Docker</em> y despliegue de aplicaciones <em>Symfony</em></h2>
        <p>Brais Arias Rio</p>
        <p>Liceo La Paz</p>
        <p><a
            href="https://bar-liceo-23.gitlab.io/daw/docker-deployment/">https://bar-liceo-23.gitlab.io/daw/docker-deployment/</a>
        </p>
        <p><img src="img/cc-by-sa-88x31.png" alt="Licencia CC BY-SA" width="88" height="31"></p>
      </section>

      <section>
        <h1>¿Qué es <em>Docker</em>?</h1>
      </section>

      <section>
        <h2>Qué es <em>Docker</em>?</h2>
        <ul>
          <li>Sistema de <em>virtualización</em></li>
          <li>Basado en <em>contenedores</em></li>

          <li>Software libre (Apachev2)</li>

          <li><a href="https://www.docker.com/">https://www.docker.com/</a></li>
        </ul>
        <img src="img/Docker_Container_Engine_logo.png" height="5%" alt="Logo de Docker">
      </section>

      <section>
        <h2>Usos de <em>Docker</em></h2>
        <ul>
          <li>Automatización de despliegues
            <ul>
              <li>Orquestación</li>
              <li>Facilita la escalabilidad horizontal</li>
            </ul>
          </li>
          <li>Aislamiento y seguridad de aplicaciones</li>
          <li>Entorno de pruebas</li>
          <li>Compilación repoducible (Repoducible Builds)</li>
        </ul>
        <img src="img/Docker_Container_Engine_logo.png" height="5%" alt="Logo de Docker">
      </section>

      <section data-background-image="img/container-4203677_1280.jpg">
        <h2>Virtualización con Contenedores</h2>
        <ul>
          <li>Virtualización ligera</li>
          <li>Aislamiento de recursos<ul>
              <li>Procesos - PID</li>
              <li>Sistema de ficheros</li>
              <li>Red</li>
            </ul>
          </li>
        </ul>
      </section>

      <section>
        <h2><em>Contenedores</em> vs <em>Máquinas virtuales</em></h2>
        <img src="img/vm_vs_container_arch.png" width="90%" alt="Comparing Virtual Machines and Containers">
        <small class="caption">Comparing Virtual Machines and Containers. Source:
          https://medium.com/@faizanbashir/docker-containers-101-e47f594a0ed</small>
      </section>


      <section>
        <h2><em>Contenedores</em> vs <em>Máquinas virtuales</em></h2>
        <img src="img/vm_vs_container_ram.jpg" width="80%" alt="Memory consumption of VMs vs Dockers">
        <small class="caption">Memory consumption of VMs vs Dockers. Source:
          https://devopedia.org/docker</small>
      </section>

      <section>
        <h1>Ecosistema <em>Docker</em></h1>
      </section>

      <section>
        <h2>Ecosistema <em>Docker</em></h2>
        <ul>
          <li><em>Docker Engine</em>: <span class="peque">Núcleo de Docker, gestiona la creación, ejecución, etc de loc
              contenedores</span></li>
          <li><em>Docker Hub</em>: <span class="peque">Repositorio oficial de imágenes de Docker</span></li>
          <li><em>Docker Compose</em>: <span class="peque">Herramienta para definir aplicaciones/sistemas compuestos de
              contenedores</span>
          </li>
        </ul>
      </section>

      <section>
        <h2>Qué se maneja con <em>Docker</em>?</h2>
        <ul>
          <li><em>Imágenes</em>: <span class="peque">plantilla estática para creación de contenedores</span>
            <ul>
              <li class="peque">Dockerfile: <a
                  href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/php-dockerfile/Dockerfile?ref_type=heads">ejemplo
                  PHP</a> - <a
                  href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/spring-dockerfile/Dockerfile?ref_type=heads">ejemplo
                  Java</a> - <a
                  href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/python-dockerfile/Dockerfile?ref_type=heads">ejemplo
                  Python</a>
              </li>
            </ul>
          </li>
          <li><em>Contenedores</em>: <span class="peque">espacios aislados para ejecutar y lanzar aplicaciones</span>
          </li>
          <li><em>Volúmenes</em>: <span class="peque">espacios para mantener información más allá de la vida de un
              contenedor</span></li>
          <li><em>Red</em> y mapeo de puertos: <span class="peque">para poder acceder a servicios de dentro del
              contenedor</span>
          </li>
        </ul>
      </section>

      <section>
        <h2><em>Comandos</em> básicos 1</h2>
        <ul>
          <li><span class="command peque azul">docker search &lt;pattern&gt;</span><br><span class="mais-peque">Busca en
              el <em>repositorio</em> una imagen que siga el <em>patrón</em></span></li>
          <li><span class="command peque azul">docker pull &lt;image&gt;</span><br><span class="mais-peque">Obtiene del
              <em>repositorio</em> la imagen</span></li>
          <li><span class="command peque azul">docker images</span><br><span class="desc">Lista las <em>imágenes</em>
              existentes en el sistema</span></li>
          <li><span class="command peque azul">docker run &lt;image&gt; &lt;comando&gt;</span><br><span
              class="mais-peque">Inicia un
              nuevo contenedor de la imagen <em>image</em> y lanza en él un comando</span></li>
        </ul>
      </section>

      <section>
        <h2><em>Comandos</em> básicos 2</h2>
        <ul>
          <li><span class="command peque azul">docker ps [-a]</span><br><span class="mais-peque"><em>Lista</em> los
              contenedores</span>
          </li>
          <li><span class="command peque azul">docker start &lt;ID|nombre contenedor&gt;</span><br><span
              class="mais-peque"><em>Inicia</em>
              un contenedor</span></li>
          <li><span class="command peque azul">docker stop &lt;ID|nombre contenedor&gt;</span><br><span
              class="mais-peque"><em>Para</em> un
              contenedor</span></li>
          <li><span class="command peque azul">docker rm &lt;ID|nombre contenedor&gt;</span><br><span
              class="mais-peque"><em>Elimina</em> el contenedor</span>
          </li>
        </ul>
      </section>

      <section>
        <h2><em>Comandos</em> básicos 3</h2>
        <ul>
          <li><span class="command peque azul">docker port &lt;contenedor&gt;</span><br><span class="mais-peque">Lista
              el
              <em>mapeo de puertos</em> del contenedor</span></li>
          <li><span class="command peque azul">docker exec &lt;ID|nombre contenedor&gt; &lt;comando&gt;</span><br><span
              class="mais-peque">Ejecuta el <em>comando</em> en un contenedor</span></li>
          <li><span class="command peque azul">docker logs [opciones] &lt;ID|nombre contenedor&gt;</span><br><span
              class="mais-peque">Muestra los <em>logs</em> de un contenedor</span></li>
          <li><span class="command peque azul">docker volume &lt;comando&gt;</span><br><span class="mais-peque">Gestiona
              <em>volúmenes</em>, comandos disponibles: (ls, create, rm, ...) </span></li>
        </ul>
      </section>

      <section>
        <h2>Ejemplos de <em>Comandos</em> 1</h2>
        <ul>
          <li><span class="command peque azul">docker search mysql</span></li>
          <li><span class="command peque azul">docker run --name my-mysql -e MYSQL_ROOT_PASSWORD=myPass -d
              mysql:latest</span><br>
            <span class="mais-peque">Crea un contenedor a partir de la imagen <em>mysql</em> con un nombre y una
              <em>variable de
                entorno</em> concretos</span>
          </li>
          <li><span class="command peque azul">docker volume create myVol
            </span><br><span class="mais-peque"><em>Crea</em> un volumen con nombre <em>myVol</em></span></li>
        </ul>
      </section>

      <section>
        <h2>Ejemplos de <em>Comandos</em> 2</h2>
        <ul>
          <li><span class="command peque azul">docker run --name my-mysql -e MYSQL_ROOT_PASSWORD=myPass -d mysql:latest
              -v
              myVol:/ruta/en/el/contenedor</span><br>
            <span class="mais-peque">Además de lo anterior <em>asigna el volumen</em> al contenedor</span>
          </li>
          <li><span class="command peque azul">docker run --name my-mysql -p 33306:3306 -e MYSQL_ROOT_PASSWORD=myPass -v
              myVol:/ruta/en/el/contenedor -d mysql:latest</span><br>
            <span class="mais-peque">Además de lo anterior <em>mapea</em> el puerto 33306 de la máquina host al puerto
              3306 del contenedor</span>
          </li>
        </ul>
      </section>
      <section>
        <h1>Docker<br><em>Compose</em></h1>
      </section>

      <section>
        <h2>Docker <em>Compose</em></h2>
        <ul>
          <li>Definición de Aplicaciones Docker <em>multi-container</em></li>
          <li>Fichero <em>YAML</em> (<span class="command peque">docker-compose.yml</span>)</li>
          <li>Automatización de procesos
            <ul>
              <li>Creación/<em>definición</em> de servicios, containers, imágenes, volúmenes</li>
              <li>Asignación de <em>volúmenes</em></li>
              <li><em>Mapeo</em> de puertos</li>
              <li><em>Inicio</em> y <em>ejecución</em> de aplicación</li>
            </ul>
          </li>
        </ul>
      </section>

      <section>
        <h2>Docker <em>Compose</em></h2>
        <h3>Ejemplos de fichero YAML</h3>
        <ul>
          <li><a
            href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/docker-compose/java/docker-compose.yml?ref_type=heads">Stack Java</a></li>
          <li><a
            href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/docker-compose/js/docker-compose.yml?ref_type=heads">Stack JavaScript</a></li>
          <li><a
            href="https://gitlab.com/bar-liceo-23/daw/docker-deployment/-/blob/main/example/docker-compose/php/docker-compose.yml?ref_type=heads">Stack PHP</a></li>
        </ul>
      </section>

      <section>
        <h2>Docker <em>Compose</em></h2>
        <h3>Comandos</h3>
        <ul>
          <li><span class="command peque azul">docker-compose up</span><br>
            <span class="mais-peque">Inicia <em>todos</em> los servicios necesarios</span>
          </li>
          <li><span class="command peque azul">docker-compose down</span><br>
            <span class="mais-peque">Para todos los <em>contenedores</em></span>
          </li>
        </ul>
      </section>

      <section>
        <h2>Despliegue de Aplicación <em>Symfony</em> con <em>Docker</em></h2>
      </section>

      <section>
        <h2>Despliegue de Aplicación <em>Symfony</em> con <em>Docker</em></h2>
        <p class="peque">De forma general para desplegar aplicaciones Symfony:</p>
        <ol class="peque">
          <li>Proyecto Symfony funcionando</li>
          <li>Creamos/editamos fichero de docker-compose</li>
          <li>Ejecutamos <span class="command peque azul">docker-compose up</span></li>
          <li>Configuración de Apache como proxy inverso</li>
        </ol>
        <p>Más información <a href="https://symfony.com/doc/6.4/setup/docker.html">aquí</a></p>
      </section>

      <section>
        <h2>Proyecto <em>Symfony</em></h2>
        <p>Usamos el proyecto que queramos. En este ejemplo:<br>
          <a class="peque"
            href="https://github.com/braisarias/my-luckynumber-symfony">https://github.com/braisarias/my-luckynumber-symfony</a>
        </p>
      </section>

      <section>
        <h2>Fichero de <em>configuración</em></h2>
        <p>En el <span class="command">docker-compose.yml</span> (<a
            href="https://github.com/braisarias/my-luckynumber-symfony/blob/main/docker-compose.yml">ejemplo</a>) se
          define que necesita nuestra aplicación, por ejemplo:
        </p>
        <ul class="peque">
          <li>Apache</li>
          <li>PHP</li>
          <li>Symfony</li>
          <li>MySQL / MariaDB / PostgreSQL</li>
        </ul>
      </section>

      <section>
        <h2>Configuramos con <em>symfony-docker</em></h2>
        <p>Antes de lanzar nuestra aplicación con Docker, la vamos a configurar y ejecutar según nos <a
            href="https://github.com/dunglas/symfony-docker/blob/main/docs/existing-project.md">dice la
            documentación</a>
        </p>
      </section>
      <section>
        <h2><em>Construír</em> contenedor y <em>ejecutarlo</em></h2>
        <ul class="peque">
          <li>
            Como último paso ejecutamos el contenedor
          </li>
          <li>
            Con el comando <span class="command azul peque">docker-compose up -d</span> se construye(n) y se
            lanza(n) el/los contenedor(es) necesarios en segundo plano
          </li>
        </ul>
      </section>

      <section>
        <h2>¡Ya <em>está</em>!</h2>
        <p>
          Ya está desplegada nuestra aplicación,<br>podemos probarla accediendo a la URL:<br> <a class="command"
            href="http://localhost/">http://localhost/</a>
        </p>
      </section>

      <section>
        <h2>Proxy inverso</h2>
        <p>Si tenemos varias aplicaciones en nuestro servidor seguramente necesitaremos un <em>Proxy Inverso</em></p>
        <p><img src="img/reverse-proxy-arch.png" height="100%" alt="Instalación de Docker en Debian"
            style="background-color: white;"></p>
        <small class="caption">Implementación de Proxy Inverso. Source:
          <a
            href="https://httpd.apache.org/docs/2.4/howto/reverse_proxy.html">https://httpd.apache.org/docs/2.4/howto/reverse_proxy.html</a></small>
      </section>

      <section>
        <h1>Continuar con <em>Docker</em></h1>
      </section>

      <section>
        <h2>Continuar con Docker 1</h2>
        <ul>
          <li>
            edX:
            <ul>
              <li><a
                  href="https://www.edx.org/professional-certificate/linuxfoundationx-introduction-to-devops-practices-and-tools">Programa
                  formativo introductorio a DevOps</a> con posibilidad de certificado</li>
              <li>
                <a href="https://www.edx.org/course/introduction-to-cloud-infrastructure-technologies">Curso
                  Introducción a tecnologías de infraestructura cloud</a>
              </li>
            </ul>
          </li>
        </ul>
      </section>

      <section>
        <h2>Continuar con Docker 2</h2>
        <ul>
          <li>
            Coursera:
            <ul>
              <li><a href="https://www.coursera.org/projects/docker-for-absolute-beginners">Proyecto guiado de Docker
                  para
                  principiantes</a></li>
              <li>
                <a href="https://www.coursera.org/projects/containerization-using-docker">Proyecto guiado de
                  containerización con Docker</a>
              </li>
            </ul>
          </li>
        </ul>
      </section>

      <section>
        <h2>Continuar con Docker 3</h2>
        <ul>
          <li>Openwebinars:
            <ul>
              <li>
                <a href="https://openwebinars.net/cursos/docker-kubernetes-openshift/">Taller de Docker, Kubernetes y
                  Openshift</a>
              </li>
              <li>
                <a href="https://openwebinars.net/cursos/docker/">Curso de Docker para Desarrolladores</a>
              </li>
              <li>
                <a href="https://openwebinars.net/cursos/docker-introduccion/"> Curso de Introducción a Docker </a>
              </li>
            </ul>
          </li>
        </ul>
      </section>

      <section id="contraPortada">
        <h2>Introducción a <em>Docker</em> y despliegue de aplicaciones <em>Symfony</em></h2>
        <p>Brais Arias Rio</p>
        <p>Liceo La Paz</p>
        <p><a
            href="https://bar-liceo-23.gitlab.io/daw/docker-deployment/">https://bar-liceo-23.gitlab.io/daw/docker-deployment/</a>
        </p>
        <p><img src="img/cc-by-sa-88x31.png" alt="Licencia CC BY-SA" width="88" height="31"></p>
      </section>

    </div>
  </div>

  <footer class="authors">
    <div style="position:absolute; left: 45px; bottom: 45px;">
      <ul style="clear:both; color: #666;">
        <li style="display: inline-block;">Brais Arias Rio</li> -
        <li style="display: inline-block;"><a href="https://www.liceolapaz.com/" target="_blank"
            style="color: #996">Liceo La Paz</a></li>
      </ul>
    </div>
  </footer>

  <script src="reveal.js/dist/reveal.js"></script>
  <script src="reveal.js/plugin/notes/notes.js"></script>
  <script src="reveal.js/plugin/markdown/markdown.js"></script>
  <script src="reveal.js/plugin/highlight/highlight.js"></script>
  <script>
    // More info about initialization & config:
    // - https://revealjs.com/initialization/
    // - https://revealjs.com/config/
    Reveal.initialize({
      hash: true,

      // Learn about plugins: https://revealjs.com/plugins/
      plugins: [RevealMarkdown, RevealHighlight, RevealNotes]
    });
  </script>
</body>

</html>